LeetCode in Kotlin

Medium

You are given two string arrays creators and ids, and an integer array views, all of length n. The ith video on a platform was created by creator[i], has an id of ids[i], and has views[i] views.

The popularity of a creator is the sum of the number of views on all of the creator’s videos. Find the creator with the highest popularity and the id of their most viewed video.

Return a 2D array of strings answer where answer[i] = [creatori, idi] means that creatori has the highest popularity and idi is the id of their most popular video. The answer can be returned in any order.

Example 1:

Input: creators = [“alice”,”bob”,”alice”,”chris”], ids = [“one”,”two”,”three”,”four”], views = [5,10,5,4]

Output: [[“alice”,”one”],[“bob”,”two”]]

Explanation:

The popularity of alice is 5 + 5 = 10.

The popularity of bob is 10.

The popularity of chris is 4.

alice and bob are the most popular creators.

For bob, the video with the highest view count is “two”.

For alice, the videos with the highest view count are “one” and “three”.

Since “one” is lexicographically smaller than “three”, it is included in the answer.

Example 2:

Input: creators = [“alice”,”alice”,”alice”], ids = [“a”,”b”,”c”], views = [1,2,2]

Output: [[“alice”,”b”]]

Explanation:

The videos with id “b” and “c” have the highest view count.

Since “b” is lexicographically smaller than “c”, it is included in the answer.

Constraints:

Solution

class Solution {
    fun mostPopularCreator(creators: Array<String>, ids: Array<String>, views: IntArray): List<List<String>> {
        val totalViews = HashMap<String, Long>()
        val maxView = HashMap<String, Int>()
        var globalMaxView: Long = 0
        for (i in creators.indices) {
            val currentView = totalViews.getOrDefault(creators[i], 0L) + views[i]
            globalMaxView = Math.max(currentView, globalMaxView)
            totalViews[creators[i]] = currentView
            val lastIndex = maxView.getOrDefault(creators[i], -1)
            if (!maxView.containsKey(creators[i]) || views[lastIndex] < views[i] ||
                views[lastIndex] == views[i] && ids[lastIndex].compareTo(
                        ids[i]
                    ) > 0
            ) {
                maxView[creators[i]] = i
            }
        }
        val res: MutableList<List<String>> = ArrayList()
        for ((key, value) in totalViews) {
            if (value == globalMaxView) {
                res.add(listOf(key, ids[maxView[key]!!]))
            }
        }
        return res
    }
}